import pencilFlow from '@ray-js/pencil-flow';

const { Shape } = pencilFlow;

class Slider extends Shape {
  constructor(data) {
    super();
    this.data = data;
  }

  draw() {
    this.clear();
    const ctx = this;
    const offset = this.data.offset;
    const width = 20; // 竖条宽度
    const radius = 10; // 圆角半径
    const height = 100 + radius * 2; // 竖条高度
    const x = 320 /* 竖条左侧中心点x坐标 */;
    const y = 50 /* 竖条顶部中心点y坐标 */;

    // 绘制圆角矩形
    ctx.beginPath();
    ctx.moveTo(x + radius, y);
    ctx.lineTo(x + width - radius, y);
    ctx.arcTo(x + width, y, x + width, y + radius, radius);
    ctx.lineTo(x + width, y + height - radius);
    ctx.arcTo(x + width, y + height, x + width - radius, y + height, radius);
    ctx.lineTo(x + radius, y + height);
    ctx.arcTo(x, y + height, x, y + height - radius, radius);
    ctx.lineTo(x, y + radius);
    ctx.arcTo(x, y, x + radius, y, radius);
    ctx.closePath();
    ctx.fillStyle("rgba(255,255,255,0.16)");
    ctx.strokeStyle("transparent")
    ctx.fill();

    // 绘制内部白色圆形
    const circleRadius = radius; // 圆形半径，不超过圆角大小
    const circleX = x + width / 2;  // 圆心 X 坐标
    const circleY = y + circleRadius + offset; // 圆心 Y 坐标

    ctx.beginPath();
    ctx.arc(circleX, circleY, circleRadius, 0, Math.PI * 2);
    ctx.fillStyle("#FFFFFF"); // 白色填充
    ctx.strokeStyle("transparent")
    ctx.fill();
  }
}

export default Slider;
