import dpParser from './parsers';
import { lampSchemaMap } from '../schema';

const { music_data, dreamlightmic_music_data, dreamlight_scene_mode, control_data, paint_colour_data, favorite } = lampSchemaMap;

export const protocols = {
  [control_data.code]: dpParser.ColorDataTransformer,
  [music_data.code]: dpParser.MusicTransformer,
  [dreamlightmic_music_data.code]: dpParser.MicMusicTransformer,
  [dreamlight_scene_mode.code]: dpParser.SceneTransformer,
  [paint_colour_data.code]: dpParser.PaintColourDataTransformer,
  [favorite.code]: dpParser.FavTransformer,
};
